<?php

include_once("Expresso.php");

class Catalog extends Expresso {	
	
	public function getUserContacts($params){
		if($this->isLoggedIn($params)) {
			if($params && $params['contactID'] > 0)	
				$query_contact = 'A.id_contact='.$params['contactID'].' and';
			
			$query = 'select B.id_typeof_contact_connection, A.photo, A.id_contact, A.alias, A.given_names, A.family_names, A.names_ordered, A.birthdate, A.notes, C.connection_value from phpgw_cc_contact A, '.
				'phpgw_cc_contact_conns B, phpgw_cc_connections C where A.id_contact = B.id_contact and B.id_connection = C.id_connection '.
				' and '.$query_contact.' A.id_owner='.$this -> getUserId().' group by '.
				' B.id_typeof_contact_connection, A.photo, A.id_contact, A.alias, A.given_names, A.family_names,A.names_ordered,A.birthdate, A.notes,C.connection_value	order by lower(A.names_ordered)';
			
			if (!$this->getDb()->query($query))
				return false;
			
			$contacts = array();
			while($this->getDb()->next_record()) {
				$row = $this->getDb()->row();
				$id = $row['id_contact'];
				$contactType = ($row['id_typeof_contact_connection'] == 1 ? 'contactPhones' : 'contactMails');				
				
				if($contacts[$id] != null){
					$contacts[$id][$contactType][] = $row['connection_value'];
				}	
				else{
					$contacts[$id] = array(
						'contactID'		=> $row['id_contact'],
						$contactType	=> array($row['connection_value']),						
						'contactAlias' => ($row['alias'] != null ?  mb_convert_encoding($row['alias'],"UTF8", "ISO_8859-1") : ""),
						'contactFirstName'	=> ($row['given_names'] != null ?  mb_convert_encoding($row['given_names'],"UTF8", "ISO_8859-1") : ""),
						'contactLastName' 	=> ($row['family_names'] != null ?  mb_convert_encoding($row['family_names'],"UTF8", "ISO_8859-1") : ""),
						'contactFullName' 	=> ($row['names_ordered'] != null ? mb_convert_encoding($row['names_ordered'],"UTF8", "ISO_8859-1") : ""),
						'contactBirthDate'	=> ($row['birthdate'] != null ? $row['birthdate'] : ""),
						'contactNotes' 		=> ($row['notes'] != null ?  mb_convert_encoding($row['notes'],"UTF8", "ISO_8859-1") : ""),
						'contactHasImagePicture' => ($row['photo'] != null ? 1 : 0),
					);
				}				
			}
			$this->result = array ('contacts' => array_values($contacts));
		}
		return $this->getResponse();
	}	
	
	public function getImagePicture($params){		
		if($this->isLoggedIn($params) && $params['contactID'] > 0) {			
			$query = 'select A.id_contact, A.photo from phpgw_cc_contact A where A.id_contact='.$params['contactID'].' and A.id_owner='.$this -> getUserId();		
			if (!$this->getDb()->query($query))
				return false;

			$contact = array();
			if($this->getDb()->next_record()) {
				$row = $this->getDb()->row();
				if($row['photo'] != null) {
					$contact[] = array(
						'contactID'		=> $row['id_contact'],
						'contactImagePicture'	=> ($row['photo'] != null ? base64_encode($row['photo']) : "")
					);
				}			
			}
			$this->result = array ('contacts' => $contact);
		}
		return $this->getResponse();
	}	
	
	public function getGlobalContacts($params){
		
		if($this->isLoggedIn($params)) {
			$this->result = array ('contacts' => $contacts);
		}
		return $this->getResponse();
	}
}